package laboratoire4;

import java.util.Stack;

public class MovingPusher extends Pusher implements MovingPawn {
    private final Stack<PawnMovement> previousMoves = new Stack<>();

    public MovingPusher(Player player, int row, int col) {
        super(player, row, col);
    }

    @Override
    public void move(PawnMovement movement) {
        previousMoves.push(movement);
        super.move(movement);
    }

    @Override
    public void revertMove() {
        PawnMovement move = previousMoves.pop();
        setRow(row - getDirection());
        setCol(col - move.getMove());
    }
}
