package laboratoire4;

public class Pusher extends Pawn {
    public Pusher(Player player, int row, int col) {
        super(player, row, col);
    }

    @Override
    public boolean isPusher() {
        return true;
    }

    @Override
    public boolean isMoveReallyValid(IPawn[][] board, PawnMovement movement) {
        IPawn to = board[getRow() + getDirection()][getCol() + movement.getMove()];

        if (to == null) {
            return true;
        }

        if (to.getPlayer() == player) {
            return false;
        }

        return movement != PawnMovement.STRAIGHT;
    }

    @Override
    public String toString() {
        return String.format("Pusher{%s, %s}", player, getPosition());
    }
}
